        COMMENT /
;
;Program Set040 definition file
;This file defines a structure for our own
;use. This structure will hold all values
;needed to remove a FASTROM setup and free
;all allocated memory.  It also defines an
;EasyRequestArgs structure for the function
;called used to switch processors on a PP&S
;68040 card      
        /          


TAB             equ       9                

;fr_id will hold one of three possible id's.
;NICS = FASTROM SETUP
;KICK = KICKROM-CHIPROM SETUP
;FAST = KICKROM-FASTROM SETUP

                rsreset
fr_id           rs.l   1
fr_kickmem      rs.l   1
fr_table1       rs.l   1
fr_table2       rs.l   1
fr_table3       rs.l   1
fr_table4       rs.l   1
fr_table5       rs.l   1
fr_itt0         rs.l   1
fr_itt1         rs.l   1
fr_dtt0         rs.l   1
fr_dtt1         rs.l   1
fr_struct       rs.l   1
fr_chiploc      rs.w   1
fr_SIZEOF       rs.w   0                               

;easyrequest struct

easyreq         dc.l     es_SIZEOF
                dc.l     0
                dc.l     estitle
                dc.l     estext
                dc.l     eschange
                                
esidcmp         dc.l     0
estitle         dc.b     'Set040 Request',0
estext          dc.b     'Change from %ld CPU to %ld CPU?',0
eschange        dc.b     'CHANGE|'                             
esabort         dc.b     'ABORT',0
esboot          dc.b      'Reboot Now..',$0a
                dc.b      ' or Abort.',0 
eskick          dc.b      'This is a SuperKickstart disk',$0a
                dc.b      'Load Kickstart V1.3 or V2.0?',0
eskickgads      dc.b     '1.3|2.0',0                
disktext        dc.b      '  Insert a SuperKickstart or ',$0a
                dc.b      'Kickstart disk into drive %4.4s',0
diskgads        dc.b     'OK|ABORT',0                
                cnop     0,4


